//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: iris_mod/farm/tx.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Msg defines the farm Msg service.
///
/// Usage: instantiate `Irismod_Farm_MsgClient`, then call methods of this protocol to make API calls.
internal protocol Irismod_Farm_MsgClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Irismod_Farm_MsgClientInterceptorFactoryProtocol? { get }

  func createPool(
    _ request: Irismod_Farm_MsgCreatePool,
    callOptions: CallOptions?
  ) -> UnaryCall<Irismod_Farm_MsgCreatePool, Irismod_Farm_MsgCreatePoolResponse>

  func destroyPool(
    _ request: Irismod_Farm_MsgDestroyPool,
    callOptions: CallOptions?
  ) -> UnaryCall<Irismod_Farm_MsgDestroyPool, Irismod_Farm_MsgDestroyPoolResponse>

  func adjustPool(
    _ request: Irismod_Farm_MsgAdjustPool,
    callOptions: CallOptions?
  ) -> UnaryCall<Irismod_Farm_MsgAdjustPool, Irismod_Farm_MsgAdjustPoolResponse>

  func stake(
    _ request: Irismod_Farm_MsgStake,
    callOptions: CallOptions?
  ) -> UnaryCall<Irismod_Farm_MsgStake, Irismod_Farm_MsgStakeResponse>

  func unstake(
    _ request: Irismod_Farm_MsgUnstake,
    callOptions: CallOptions?
  ) -> UnaryCall<Irismod_Farm_MsgUnstake, Irismod_Farm_MsgUnstakeResponse>

  func harvest(
    _ request: Irismod_Farm_MsgHarvest,
    callOptions: CallOptions?
  ) -> UnaryCall<Irismod_Farm_MsgHarvest, Irismod_Farm_MsgHarvestResponse>
}

extension Irismod_Farm_MsgClientProtocol {
  internal var serviceName: String {
    return "irismod.farm.Msg"
  }

  /// CreatePool defines a method for creating a new farm pool
  ///
  /// - Parameters:
  ///   - request: Request to send to CreatePool.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func createPool(
    _ request: Irismod_Farm_MsgCreatePool,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Irismod_Farm_MsgCreatePool, Irismod_Farm_MsgCreatePoolResponse> {
    return self.makeUnaryCall(
      path: "/irismod.farm.Msg/CreatePool",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeCreatePoolInterceptors() ?? []
    )
  }

  /// DestroyPool defines a method for destroying a existed farm pool
  ///
  /// - Parameters:
  ///   - request: Request to send to DestroyPool.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func destroyPool(
    _ request: Irismod_Farm_MsgDestroyPool,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Irismod_Farm_MsgDestroyPool, Irismod_Farm_MsgDestroyPoolResponse> {
    return self.makeUnaryCall(
      path: "/irismod.farm.Msg/DestroyPool",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeDestroyPoolInterceptors() ?? []
    )
  }

  /// AdjustPool defines a method for adjusting the farm pool params
  ///
  /// - Parameters:
  ///   - request: Request to send to AdjustPool.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func adjustPool(
    _ request: Irismod_Farm_MsgAdjustPool,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Irismod_Farm_MsgAdjustPool, Irismod_Farm_MsgAdjustPoolResponse> {
    return self.makeUnaryCall(
      path: "/irismod.farm.Msg/AdjustPool",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeAdjustPoolInterceptors() ?? []
    )
  }

  /// Stake defines a method for staking some lp token to a farm pool
  ///
  /// - Parameters:
  ///   - request: Request to send to Stake.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func stake(
    _ request: Irismod_Farm_MsgStake,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Irismod_Farm_MsgStake, Irismod_Farm_MsgStakeResponse> {
    return self.makeUnaryCall(
      path: "/irismod.farm.Msg/Stake",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeStakeInterceptors() ?? []
    )
  }

  /// Unstake defines a method for unstaking some lp token from a farm pool and
  /// withdraw some reward
  ///
  /// - Parameters:
  ///   - request: Request to send to Unstake.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func unstake(
    _ request: Irismod_Farm_MsgUnstake,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Irismod_Farm_MsgUnstake, Irismod_Farm_MsgUnstakeResponse> {
    return self.makeUnaryCall(
      path: "/irismod.farm.Msg/Unstake",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeUnstakeInterceptors() ?? []
    )
  }

  /// Harvest defines a method withdraw some reward from a farm pool
  ///
  /// - Parameters:
  ///   - request: Request to send to Harvest.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func harvest(
    _ request: Irismod_Farm_MsgHarvest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Irismod_Farm_MsgHarvest, Irismod_Farm_MsgHarvestResponse> {
    return self.makeUnaryCall(
      path: "/irismod.farm.Msg/Harvest",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeHarvestInterceptors() ?? []
    )
  }
}

internal protocol Irismod_Farm_MsgClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'createPool'.
  func makeCreatePoolInterceptors() -> [ClientInterceptor<Irismod_Farm_MsgCreatePool, Irismod_Farm_MsgCreatePoolResponse>]

  /// - Returns: Interceptors to use when invoking 'destroyPool'.
  func makeDestroyPoolInterceptors() -> [ClientInterceptor<Irismod_Farm_MsgDestroyPool, Irismod_Farm_MsgDestroyPoolResponse>]

  /// - Returns: Interceptors to use when invoking 'adjustPool'.
  func makeAdjustPoolInterceptors() -> [ClientInterceptor<Irismod_Farm_MsgAdjustPool, Irismod_Farm_MsgAdjustPoolResponse>]

  /// - Returns: Interceptors to use when invoking 'stake'.
  func makeStakeInterceptors() -> [ClientInterceptor<Irismod_Farm_MsgStake, Irismod_Farm_MsgStakeResponse>]

  /// - Returns: Interceptors to use when invoking 'unstake'.
  func makeUnstakeInterceptors() -> [ClientInterceptor<Irismod_Farm_MsgUnstake, Irismod_Farm_MsgUnstakeResponse>]

  /// - Returns: Interceptors to use when invoking 'harvest'.
  func makeHarvestInterceptors() -> [ClientInterceptor<Irismod_Farm_MsgHarvest, Irismod_Farm_MsgHarvestResponse>]
}

internal final class Irismod_Farm_MsgClient: Irismod_Farm_MsgClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Irismod_Farm_MsgClientInterceptorFactoryProtocol?

  /// Creates a client for the irismod.farm.Msg service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Irismod_Farm_MsgClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Msg defines the farm Msg service.
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Irismod_Farm_MsgProvider: CallHandlerProvider {
  var interceptors: Irismod_Farm_MsgServerInterceptorFactoryProtocol? { get }

  /// CreatePool defines a method for creating a new farm pool
  func createPool(request: Irismod_Farm_MsgCreatePool, context: StatusOnlyCallContext) -> EventLoopFuture<Irismod_Farm_MsgCreatePoolResponse>

  /// DestroyPool defines a method for destroying a existed farm pool
  func destroyPool(request: Irismod_Farm_MsgDestroyPool, context: StatusOnlyCallContext) -> EventLoopFuture<Irismod_Farm_MsgDestroyPoolResponse>

  /// AdjustPool defines a method for adjusting the farm pool params
  func adjustPool(request: Irismod_Farm_MsgAdjustPool, context: StatusOnlyCallContext) -> EventLoopFuture<Irismod_Farm_MsgAdjustPoolResponse>

  /// Stake defines a method for staking some lp token to a farm pool
  func stake(request: Irismod_Farm_MsgStake, context: StatusOnlyCallContext) -> EventLoopFuture<Irismod_Farm_MsgStakeResponse>

  /// Unstake defines a method for unstaking some lp token from a farm pool and
  /// withdraw some reward
  func unstake(request: Irismod_Farm_MsgUnstake, context: StatusOnlyCallContext) -> EventLoopFuture<Irismod_Farm_MsgUnstakeResponse>

  /// Harvest defines a method withdraw some reward from a farm pool
  func harvest(request: Irismod_Farm_MsgHarvest, context: StatusOnlyCallContext) -> EventLoopFuture<Irismod_Farm_MsgHarvestResponse>
}

extension Irismod_Farm_MsgProvider {
  internal var serviceName: Substring { return "irismod.farm.Msg" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "CreatePool":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Irismod_Farm_MsgCreatePool>(),
        responseSerializer: ProtobufSerializer<Irismod_Farm_MsgCreatePoolResponse>(),
        interceptors: self.interceptors?.makeCreatePoolInterceptors() ?? [],
        userFunction: self.createPool(request:context:)
      )

    case "DestroyPool":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Irismod_Farm_MsgDestroyPool>(),
        responseSerializer: ProtobufSerializer<Irismod_Farm_MsgDestroyPoolResponse>(),
        interceptors: self.interceptors?.makeDestroyPoolInterceptors() ?? [],
        userFunction: self.destroyPool(request:context:)
      )

    case "AdjustPool":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Irismod_Farm_MsgAdjustPool>(),
        responseSerializer: ProtobufSerializer<Irismod_Farm_MsgAdjustPoolResponse>(),
        interceptors: self.interceptors?.makeAdjustPoolInterceptors() ?? [],
        userFunction: self.adjustPool(request:context:)
      )

    case "Stake":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Irismod_Farm_MsgStake>(),
        responseSerializer: ProtobufSerializer<Irismod_Farm_MsgStakeResponse>(),
        interceptors: self.interceptors?.makeStakeInterceptors() ?? [],
        userFunction: self.stake(request:context:)
      )

    case "Unstake":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Irismod_Farm_MsgUnstake>(),
        responseSerializer: ProtobufSerializer<Irismod_Farm_MsgUnstakeResponse>(),
        interceptors: self.interceptors?.makeUnstakeInterceptors() ?? [],
        userFunction: self.unstake(request:context:)
      )

    case "Harvest":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Irismod_Farm_MsgHarvest>(),
        responseSerializer: ProtobufSerializer<Irismod_Farm_MsgHarvestResponse>(),
        interceptors: self.interceptors?.makeHarvestInterceptors() ?? [],
        userFunction: self.harvest(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Irismod_Farm_MsgServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'createPool'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeCreatePoolInterceptors() -> [ServerInterceptor<Irismod_Farm_MsgCreatePool, Irismod_Farm_MsgCreatePoolResponse>]

  /// - Returns: Interceptors to use when handling 'destroyPool'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeDestroyPoolInterceptors() -> [ServerInterceptor<Irismod_Farm_MsgDestroyPool, Irismod_Farm_MsgDestroyPoolResponse>]

  /// - Returns: Interceptors to use when handling 'adjustPool'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeAdjustPoolInterceptors() -> [ServerInterceptor<Irismod_Farm_MsgAdjustPool, Irismod_Farm_MsgAdjustPoolResponse>]

  /// - Returns: Interceptors to use when handling 'stake'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeStakeInterceptors() -> [ServerInterceptor<Irismod_Farm_MsgStake, Irismod_Farm_MsgStakeResponse>]

  /// - Returns: Interceptors to use when handling 'unstake'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeUnstakeInterceptors() -> [ServerInterceptor<Irismod_Farm_MsgUnstake, Irismod_Farm_MsgUnstakeResponse>]

  /// - Returns: Interceptors to use when handling 'harvest'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeHarvestInterceptors() -> [ServerInterceptor<Irismod_Farm_MsgHarvest, Irismod_Farm_MsgHarvestResponse>]
}
